Index: trunk/IPs/systemC/Environment/Common/include/Debug.h
===================================================================
--- trunk/IPs/systemC/Environment/Common/include/Debug.h	(revision 123)
+++ trunk/IPs/systemC/Environment/Common/include/Debug.h	(revision 124)
@@ -3,5 +3,5 @@
 
 #define DEBUG_true        true
-#define DEBUG_ENVIRONMENT false
+#define DEBUG_ENVIRONMENT true
 #define DEBUG_CACHE       false
 #define DEBUG_DATA        false
Index: trunk/IPs/systemC/Environment/include/Respons.h
===================================================================
--- trunk/IPs/systemC/Environment/include/Respons.h	(revision 123)
+++ trunk/IPs/systemC/Environment/include/Respons.h	(revision 124)
@@ -9,4 +9,5 @@
   class Respons
   {
+  public : uint32_t port   ;
   public : T1       trdid  ;  // number of thread
   public : T2       pktid  ;  // number of packet
@@ -26,5 +27,6 @@
 //     };
 
-  public : Respons (T1       trdid    ,
+  public : Respons (uint32_t port     ,
+                    T1       trdid    ,
 		    T2       pktid    ,
 		    uint32_t nb_word  ,
@@ -34,4 +36,5 @@
 		   )
     {
+      this->port      = port;
       this->trdid     = trdid;
       this->pktid     = pktid;
@@ -57,5 +60,6 @@
   public : friend std::ostream& operator<< (std::ostream& output, Respons x)
     {
-      output << x.trdid              << " " 
+      output << x.port               << " " 
+             << x.trdid              << " " 
 	     << x.pktid              << " " 
 	     << x.error              << " ";
Index: trunk/IPs/systemC/Environment/src/Environment_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/Environment/src/Environment_genMoore.cpp	(revision 123)
+++ trunk/IPs/systemC/Environment/src/Environment_genMoore.cpp	(revision 124)
@@ -30,38 +30,44 @@
 	//-----------------------------------------------------------------------------
 	{
+          // init
 	  for (uint32_t j = 0; j < param->icache_dedicated_nb_port [i]; j ++)
+            icache_rsp_val [i][j] = 0;
+
+	  for (uint32_t j = 0; j+1 < component_buffer_irsp [i]->nb_slot_use(); j ++)
       	    {
 	      // Test the number of element in the respons's buffer
-      	      if (j >= component_buffer_irsp [i]->nb_slot_use())
-      		{
-		  icache_rsp_val [i][j] = 0; // No respons
-      		}
-      	      else
-      		{
-		  queue::slot_t<irsp_t*> slot = component_buffer_irsp [i]->read(j);
+              
+              queue::slot_t<irsp_t*> slot = component_buffer_irsp [i]->read(j);
+              
+              uint32_t port = slot._data->port;
+              
+              bool val = ((slot._delay == 0) and (icache_rsp_val [i][port] == 0));
+
+              _cout(ENVIRONMENT, "buffer_irsp [%d][%d] - delay %d - port %d\n",i,j,slot._delay,port);
+
+              
+              if (val)
+                {
+                  _cout(ENVIRONMENT, "ICACHE_RSP [%d][%d] - respons valid\n",i,port);
+                  
+                  icache_rsp_val        [i][port] = 1;
+                                
+                  ICACHE_RSP_CONTEXT_ID [i][port]->write(slot._data->trdid); // TODO : test if exist
+                  ICACHE_RSP_PACKET_ID  [i][port]->write(slot._data->pktid); // TODO : test if exist
+                  ICACHE_RSP_ERROR      [i][port]->write(slot._data->error);
 		  
-		  bool val = (slot._delay == 0);
-
-		  icache_rsp_val [i][j] = (val); // respons if have a result
-
-		  if (val)
-		    {
-		      ICACHE_RSP_CONTEXT_ID [i][j]->write(slot._data->trdid); // TODO : test if exist
-		      ICACHE_RSP_PACKET_ID  [i][j]->write(slot._data->pktid); // TODO : test if exist
-		      ICACHE_RSP_ERROR      [i][j]->write(slot._data->error);
-		      
-		      for (uint32_t k = 0; k < param->iaccess_nb_instruction[i]; k ++)
-			{
-			  Ticache_instruction_t data = 0;
-			  
-			  atoi (slot._data->data[k], data, param->iaccess_size_instruction[i]/8);
-			  
-			  ICACHE_RSP_INSTRUCTION [i][j][k]->write(data);
-			}
-		    }
-		}
-
-	      ICACHE_RSP_VAL [i][j]->write (icache_rsp_val [i][j]);
-      	    }
+                  for (uint32_t k = 0; k < param->iaccess_nb_instruction[i]; k ++)
+                    {
+                      Ticache_instruction_t data = 0;
+                      
+                      atoi (slot._data->data[k], data, param->iaccess_size_instruction[i]/8);
+                      
+                      ICACHE_RSP_INSTRUCTION [i][port][k]->write(data);
+                    }
+                }
+            }
+          
+	  for (uint32_t j = 0; j < param->icache_dedicated_nb_port [i]; j ++)
+            ICACHE_RSP_VAL [i][j]->write (icache_rsp_val [i][j]);
 	}
 	
@@ -103,4 +109,6 @@
 		  if (val)
 		    {
+                      _cout(ENVIRONMENT, "DCACHE_RSP [%d][%d] - respons valid\n",i,j);
+
 		      DCACHE_RSP_CONTEXT_ID [i][j]->write(slot._data->trdid); // TODO : test if exist
 		      DCACHE_RSP_PACKET_ID  [i][j]->write(slot._data->pktid); // TODO : test if exist
Index: trunk/IPs/systemC/Environment/src/Environment_transition.cpp
===================================================================
--- trunk/IPs/systemC/Environment/src/Environment_transition.cpp	(revision 123)
+++ trunk/IPs/systemC/Environment/src/Environment_transition.cpp	(revision 124)
@@ -44,5 +44,5 @@
 	    if (ICACHE_REQ_VAL [i][j]->read() and icache_req_ack [i][j])
 	      {
-		_cout(ENVIRONMENT, "ICACHE_REQ [%d] : Transaction accepted\n",i);
+		_cout(ENVIRONMENT, "ICACHE_REQ [%d][%d] : Transaction accepted\n",i,j);
 
 		Ticache_context_t context   = ICACHE_REQ_CONTEXT_ID [i][j]->read();// TODO : test presence
@@ -83,5 +83,5 @@
 			  {
 			    uint32_t addr = address+k*(size);
-                            _cout(ENVIRONMENT,"    * addr    : %.8x\n",addr);
+                            _cout(ENVIRONMENT,"    * addr    : %.8x - ",addr);
 
 			    bus_error |= !component_data->read(addr,size,read_iram[k]);
@@ -93,5 +93,5 @@
                               }
 
-                            _cout(ENVIRONMENT,"    * inst    :");
+                            //_cout(ENVIRONMENT,"    * inst    : ");
                             for (int32_t cpt=(param->iaccess_size_instruction[i]/8)-1; cpt>=0; --cpt)
                               __cout(ENVIRONMENT, "%.2x",0xff&static_cast<uint32_t>(read_iram[k][cpt]));
@@ -144,5 +144,6 @@
 		    _cout(ENVIRONMENT, "    * push in buffer_irsp[%d]\n",i);
 
-		    irsp_t * rsp = new irsp_t(context,
+		    irsp_t * rsp = new irsp_t(j,
+                                              context,
 					      packet,
 					      param->iaccess_nb_instruction[i],
@@ -163,5 +164,5 @@
 	    if (DCACHE_REQ_VAL [i][j]->read() and dcache_req_ack [i][j])
 	      {
-		_cout(ENVIRONMENT, "DCACHE_REQ [%d] : Transaction accepted\n",i);
+		_cout(ENVIRONMENT, "DCACHE_REQ [%d][%d] : Transaction accepted\n",i,j);
 
 		Tdcache_context_t context   = DCACHE_REQ_CONTEXT_ID [i][j]->read();// TODO : test presence
@@ -339,8 +340,13 @@
 
 			  uint32_t num_ramlock           = (address - entity.segment->getBase()); // Char access
+			  uint32_t num_lock              = num_ramlock % (param->daccess_size_data [i]/8);
 			  uint32_t num_component_ramlock = entity.segment->getIndex();
 
-			  _cout(ENVIRONMENT,"    * num_ramlock           : %d\n",num_ramlock          );
-			  _cout(ENVIRONMENT,"    * num_component_ramlock : %d\n",num_component_ramlock);
+// 			  _cout(ENVIRONMENT,"    * num_ramlock           : %d\n",num_ramlock          );
+// 			  _cout(ENVIRONMENT,"    * num_lock              : %d\n",num_lock             );
+// 			  _cout(ENVIRONMENT,"    * num_component_ramlock : %d\n",num_component_ramlock);
+			  _cout(true,"    * num_ramlock           : %d\n",num_ramlock          );
+			  _cout(true,"    * num_lock              : %d\n",num_lock             );
+			  _cout(true,"    * num_component_ramlock : %d\n",num_component_ramlock);
 
 			  // No test : because out of range
@@ -352,9 +358,12 @@
 
 			  memset (read_dram[0],0,size);
-			  
+
 			  if (must_read == true)
-			    read_dram [0][0] = static_cast<char>(component_ramlock [num_component_ramlock]->read (num_ramlock));
+			    read_dram [0][num_lock] = static_cast<char>(component_ramlock [num_component_ramlock]->read (num_ramlock));
 			  if (must_write == true)
-			    read_dram [0][0] = static_cast<char>(component_ramlock [num_component_ramlock]->write(num_ramlock));
+			    read_dram [0][num_lock] = static_cast<char>(component_ramlock [num_component_ramlock]->write(num_ramlock));
+
+			  _cout(true,"    * lock                  : %d\n",(int)read_dram [0][num_lock]);
+// 			  _cout(ENVIRONMENT,"    * lock                  : %d\n",(int)read_dram [0][num_lock]);
 			  
 			  break;
@@ -506,5 +515,6 @@
 		    
 		    // Simplification : the size of a line is a multiple of size_iword (no test)
-		    drsp_t * rsp = new drsp_t(context,
+		    drsp_t * rsp = new drsp_t(j,
+                                              context,
 					      packet,
 					      1,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Configuration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Configuration.cpp	(revision 123)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Configuration.cpp	(revision 124)
@@ -47,5 +47,6 @@
 
     log_init(fromString<bool>(_simulator->getParam("debug_log_file_generate")),
-             fromString<bool>(_simulator->getParam("debug_log_file_with_pid")),
+             fromString<bool>  (_simulator->getParam("simulation_file_with_date")),
+             fromString<bool>  (_simulator->getParam("simulation_file_with_pid")),
              MORPHEO_LOG);
 
@@ -91,5 +92,9 @@
     //--------------------------------------------------
     simulation_init (fromString<double>(_simulator->getParam("simulation_nb_cycle")),
-                     fromString<double>(_simulator->getParam("simulation_nb_instruction")));
+                     fromString<double>(_simulator->getParam("debug_nb_cycle")),
+                     fromString<double>(_simulator->getParam("simulation_nb_instruction")),
+                     fromString<bool>  (_simulator->getParam("simulation_file_with_date")),
+                     fromString<bool>  (_simulator->getParam("simulation_file_with_pid"))
+                     );
 
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_req.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_req.cpp	(revision 123)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_req.cpp	(revision 124)
@@ -20,4 +20,5 @@
   {
     log_begin(Icache_Access,FUNCTION);
+    log_function(Icache_Access,FUNCTION,_name.c_str());
 
     Tcontrol_t icache_req_val [_param->_nb_icache_port];
@@ -33,4 +34,6 @@
     for (uint32_t i=0; i<_param->_nb_icache_port; ++i)
       {
+//         log_printf(TRACE,Icache_Access,FUNCTION,"  * ICACHE_REQ [%d]",i);
+
 #ifdef STATISTICS
 	_internal_ICACHE_REQ_NB_ACCESS         [i] = 0;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_rsp.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_rsp.cpp	(revision 123)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_rsp.cpp	(revision 124)
@@ -19,5 +19,6 @@
   void Icache_Access::genMealy_rsp (void)
   {
-    log_begin(Icache_Access,FUNCTION);
+    log_begin(Icache_Access,FUNCTION); 
+    log_function(Icache_Access,FUNCTION,_name.c_str());
 
     Tcontrol_t context_rsp_val [_param->_nb_front_end][_param->_max_nb_context];
@@ -30,8 +31,13 @@
     for (uint32_t i=0; i<_param->_nb_icache_port; ++i)
       {
+        log_printf(TRACE,Icache_Access,FUNCTION,"  * ICACHE_RSP [%d]",i);
+        
 	Tcontrol_t val = PORT_READ(in_ICACHE_RSP_VAL [i]);
 	Tcontrol_t ack;
 	
 	Tcontext_t thread_id = (_param->_have_port_icache_thread_id)?PORT_READ(in_ICACHE_RSP_THREAD_ID [i]):0;
+
+        log_printf(TRACE,Icache_Access,FUNCTION,"    * val            : %d",val);
+        log_printf(TRACE,Icache_Access,FUNCTION,"    * thread_id      : %d",thread_id);
 
 #ifdef DEBUG_TEST
@@ -44,4 +50,7 @@
 	    Tcontext_t front_end_id = _param->_translate_thread_to_context  [thread_id];
 	    Tcontext_t context_id   = _param->_translate_thread_to_front_end[thread_id];
+
+            log_printf(TRACE,Icache_Access,FUNCTION,"    * front_end_id   : %d",front_end_id);
+            log_printf(TRACE,Icache_Access,FUNCTION,"    * context_id     : %d",context_id  );
 	    
 // 	    log_printf(TRACE,Icache_Access,FUNCTION,"thread_id     : %d",thread_id);
@@ -84,5 +93,9 @@
     for (uint32_t i=0; i<_param->_nb_front_end; ++i)
       for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
-	PORT_WRITE(out_CONTEXT_RSP_VAL [i][j], context_rsp_val [i][j]);
+        {
+          log_printf(TRACE,Icache_Access,FUNCTION,"  * CONTEXT_RSP_VAL [%d][%d] : %d",i,j,context_rsp_val [i][j]);
+
+          PORT_WRITE(out_CONTEXT_RSP_VAL [i][j], context_rsp_val [i][j]);
+        }
 
     log_end(Icache_Access,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h	(revision 123)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h	(revision 124)
@@ -14,5 +14,4 @@
 #endif
 
-#include <iostream>
 #include "Common/include/ToString.h"
 #include "Common/include/Debug.h"
@@ -31,4 +30,7 @@
 #endif
 #include "Behavioural/include/Usage.h"
+
+#include <iostream>
+#include <fstream>
 
 namespace morpheo {
@@ -194,5 +196,11 @@
   private   : Tcontrol_t                      internal_DCACHE_REQ_VAL         ;
   private   : Tselect_queue_t                 internal_DCACHE_REQ_SELECT_QUEUE;
-#endif
+
+#if defined(DEBUG) and defined(DEBUG_Load_store_unit) and (DEBUG_Load_store_unit == true)
+  private   : std::ofstream                 * memory_log_file;
+#endif
+
+#endif
+
 
     // -----[ methods ]---------------------------------------------------
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Parameters.h	(revision 123)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Parameters.h	(revision 124)
@@ -43,4 +43,6 @@
   public : uint32_t            _nb_general_register          ;
   public : uint32_t            _nb_special_register          ;
+  public : uint32_t            _nb_thread                    ;
+  public : bool              * _num_thread_valid             ; //[nb_thread]
 
 //public : uint32_t            _size_address_store_queue             ;
@@ -66,5 +68,5 @@
   public : Tdcache_address_t   _mask_address_msb                     ;
   public : Tdcache_address_t   _mask_check_hit_byte                  ;
-  
+
     //-----[ methods ]-----------------------------------------------------------
   public : Parameters  (uint32_t            size_store_queue       ,
@@ -84,4 +86,6 @@
 			uint32_t            nb_general_register    ,
 			uint32_t            nb_special_register    ,
+                        uint32_t            nb_thread              ,
+                        bool              * num_thread_valid       , //[nb_thread]
                         bool                is_toplevel=false);
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp	(revision 123)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp	(revision 124)
@@ -9,4 +9,5 @@
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h"
 #include "Behavioural/include/Allocation.h"
+#include "Common/include/Filename.h"
 
 namespace morpheo                    {
@@ -177,4 +178,24 @@
 #endif
 
+#if defined(DEBUG) and defined(DEBUG_Load_store_unit) and (DEBUG_Load_store_unit == true)
+    directory_init ();
+
+    memory_log_file = new std::ofstream [_param->_nb_thread];
+    for (uint32_t i=0; i<_param->_nb_thread; ++i)
+      if (_param->_num_thread_valid [i])
+        {
+          
+          std::string filename = morpheo::filename(MORPHEO_LOG,
+                                                   "Memory_access-thread_"+toString(i),
+                                                   "",
+                                                   "log",
+                                                   _simulation_file_with_date,
+                                                   _simulation_file_with_pid ,
+                                                   true);
+          
+          memory_log_file [i].open(filename.c_str() ,std::ios::out | std::ios::trunc);
+        }
+#endif
+
     log_printf(FUNC,Load_store_unit,FUNCTION,"End");
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_deallocation.cpp	(revision 123)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_deallocation.cpp	(revision 124)
@@ -121,4 +121,11 @@
     delete    _component;
 
+#if defined(DEBUG) and defined(DEBUG_Load_store_unit) and (DEBUG_Load_store_unit == true)
+    for (uint32_t i=0; i<_param->_nb_thread; ++i)
+      if (_param->_num_thread_valid [i])
+        {
+          memory_log_file [i].close();
+        }
+#endif
 
     log_printf(FUNC,Load_store_unit,FUNCTION,"End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp	(revision 123)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp	(revision 124)
@@ -8,4 +8,5 @@
 
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h"
+#include "Behavioural/include/Identification.h"
 
 namespace morpheo                    {
@@ -950,4 +951,23 @@
 		  _store_queue [reg_STORE_QUEUE_PTR_READ]._state = STORE_QUEUE_COMMIT;
 
+#if defined(DEBUG) and defined(DEBUG_Load_store_unit) and (DEBUG_Load_store_unit == true)
+	            {
+	              // log file
+                      Tcontext_t num_thread    = get_num_thread(_store_queue [reg_STORE_QUEUE_PTR_READ]._context_id   , _param->_size_context_id   ,
+                                                                _store_queue [reg_STORE_QUEUE_PTR_READ]._front_end_id , _param->_size_front_end_id ,
+                                                                _store_queue [reg_STORE_QUEUE_PTR_READ]._ooo_engine_id, _param->_size_ooo_engine_id);
+
+	              memory_log_file [num_thread] 
+	            	<< "[" << simulation_cycle() << "] "
+	            	<< std::hex
+                        << "@ 0x" << std::setfill('0') << std::setw(_param->_size_general_data/4) << _store_queue [reg_STORE_QUEUE_PTR_READ]._address << " -[ Write ]-> 0x" << std::setfill('0') << std::setw(_param->_size_general_data/4) << _store_queue [reg_STORE_QUEUE_PTR_READ]._wdata << " "
+	            	<< std::dec
+	            	<< "{" << toString(_store_queue [reg_STORE_QUEUE_PTR_READ]._operation) << "}";
+	              
+	              memory_log_file [num_thread] << std::endl;
+	            }
+#endif	    
+
+
 		  break;
 		}
@@ -1125,4 +1145,22 @@
                 _load_queue [packet_id]._rdata = data;
 		
+#if defined(DEBUG) and defined(DEBUG_Load_store_unit) and (DEBUG_Load_store_unit == true)
+                {
+                  // log file
+                  Tcontext_t num_thread    = get_num_thread(_load_queue [packet_id]._context_id   , _param->_size_context_id   ,
+                                                            _load_queue [packet_id]._front_end_id , _param->_size_front_end_id ,
+                                                            _load_queue [packet_id]._ooo_engine_id, _param->_size_ooo_engine_id);
+                  
+                  memory_log_file [num_thread] 
+                    << "[" << simulation_cycle() << "] "
+                    << std::hex
+                    << "@ 0x" << std::setfill('0') << std::setw(_param->_size_general_data/4) << _load_queue [packet_id]._address << " -[ Read  ]-> 0x" << std::setfill('0') << std::setw(_param->_size_general_data/4) << _load_queue [packet_id]._rdata << " "
+                    << std::dec
+                    << "{" << toString(_load_queue [packet_id]._operation) << "}";
+                  
+                  memory_log_file [num_thread] << std::endl;
+                }
+#endif	    
+
 		if (error != DCACHE_ERROR_NONE)
 		  {
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters.cpp	(revision 123)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters.cpp	(revision 124)
@@ -36,4 +36,6 @@
 			  uint32_t            nb_general_register    ,
 			  uint32_t            nb_special_register    ,
+                          uint32_t            nb_thread              ,
+                          bool              * num_thread_valid       , //[nb_thread]
                           bool                is_toplevel)
   {
@@ -54,4 +56,6 @@
     _nb_general_register                   = nb_general_register    ;
     _nb_special_register                   = nb_special_register    ;
+    _nb_thread                             = nb_thread              ;
+    _num_thread_valid                      = num_thread_valid       ;
     
     _size_speculative_access_queue_ptr     = log2(size_speculative_access_queue);
@@ -149,4 +153,5 @@
   {
     log_printf(FUNC,Load_store_unit,FUNCTION,"Begin");
+
     log_printf(FUNC,Load_store_unit,FUNCTION,"End");
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Parameters.cpp	(revision 123)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Parameters.cpp	(revision 124)
@@ -115,5 +115,7 @@
            _nb_spr_port_read_by_bank ,
            _nb_spr_port_write_by_bank,
-           crossbar                  );
+           crossbar                  ,
+           "0" // SPR à la différence du GPR doit être initialisé à 0. (F, CY et OV = 0)
+           );
         
         __param_spr_status [i] = new morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::Parameters 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp	(revision 123)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp	(revision 124)
@@ -444,5 +444,7 @@
 	      size_special_data                ,
 	     _max_nb_special_register          ,
-	     _max_nb_general_register          );
+	     _max_nb_general_register          ,
+             _nb_thread                        ,
+             _num_thread_valid                 );
       }
 
